package rangesearch.api;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;

/** An interface to iterate over Point2Ds.  This interface makes method
 * signatures more specific and eliminates the need to cast when extracting
 * Point2Ds from a container.  */

public interface Point2DIterator extends ObjectIterator {
    /**
     * @return The point returned by the most recent next().
     * @throws java.util.NoSuchElementException when the iterator is in its
     *          initial, before-the-first-point state.
     * @throws java.lang.ClassCastException when the objects being iterated
     *          over aren't Point2Ds.
     */
    public Point2D point2D()
        throws java.util.NoSuchElementException;

    /**
     * @return The next point to consider.
     * @throws java.util.NoSuchElementException if the iterator has moved past
     *          the last edge to be seen.
     * @throws java.lang.ClassCastException when the objects being iterated
     *          over aren't Point2Ds.
     */
    public Point2D nextPoint2D()
        throws java.util.NoSuchElementException;
}
