package rangesearch.api;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;

/** An interface describing search over a set of 2D points and returns those 
 * points within a rectangle. */

public interface RangeSearch2D {
    /** Initializes the range searcher with a given set of points.
     * @param pi an iterator over the points to be searched.
     * @throws RangeSearchException if points can't be compared properly.
     */
    public void initialize(Point2DIterator pi)
        throws RangeSearchException;

    /** Queries the current set of points using the query rectangle r.
     * Points are considered to be within the query rectangle if they lie on or
     * within the rectangle's borders.
     * @param r the rectangle in which to query.
     * @throws RangeSearchException if points can't be compared properly.
     */
    public Point2DIterator query(Rectangle2D r)
        throws RangeSearchException;
}
