package rangesearch.ref;

import rangesearch.api.*;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;

/** An adapter between ObjectIterators and Point2DIterators.
 */

public class Point2DIteratorAdapter implements Point2DIterator {
    private ObjectIterator m_iter;

    /** @param oi the iterator to adapt to a Point2DIterator.
     */
    public Point2DIteratorAdapter(ObjectIterator oi) {
        m_iter = oi;
    }

    public Point2D point2D()
        throws java.util.NoSuchElementException {
        return (Point2D) object();
    }

    public Point2D nextPoint2D()
        throws java.util.NoSuchElementException {
        return (Point2D) nextObject();
    }

    public boolean hasNext() {
        return m_iter.hasNext();
    }

    public Object nextObject() 
        throws java.util.NoSuchElementException {
        return m_iter.nextObject();
    }

    public Object object()
        throws java.util.NoSuchElementException {
        return m_iter.object();
    }

    public void reset() {
        m_iter.reset();
    }
}

